import java.util.Scanner;
 
public class Main {
    static int[][] rotate(int[][] A) {
        int n = A.length;
        int[][] ans = new int[n][];
        for (int i = 0; i < n; i++) {
            ans[i] = new int[i + 1];
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j <= i; j++) {
                ans[i][j] = A[n - 1 - j][i - j];
            }
        }
        return ans;
    }
 
    static int[][] reflect(int[][] A) {
        int n = A.length;
        int[][] ans = new int[n][];
        for (int i = 0; i < n; i++) {
            ans[i] = new int[i + 1];
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j <= i; j++) {
                ans[i][j] = A[i][i-j];
            }
        }
        return ans;
    }
 
    static int getDiff(int[][] A, int[][] B) {
        int n = A.length;
        int res = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j <= i; j++) {
                res += A[i][j] ^ B[i][j];
            }
        }
        return res;
    }
 
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int n = sc.nextInt();
        int[][] A = new int[n][];
        int[][] B = new int[n][];
        for (int i = 0; i < n; i++) {
            A[i] = new int[i + 1];
            for (int j = 0; j <= i; j++) {
                A[i][j] = sc.nextInt();
            }
        }
        for (int i = 0; i < n; i++) {
            B[i] = new int[i + 1];
            for (int j = 0; j <= i; j++) {
                B[i][j] = sc.nextInt();
            }
        }
 
        int[][] tri0 = A;
        int[][] tri1 = rotate(tri0);
        int[][] tri2 = rotate(tri1);
        int[][] tri3 = reflect(A);
        int[][] tri4 = rotate(tri3);
        int[][] tri5 = rotate(tri4);
 
        int res = getDiff(tri0, B);
        res = Math.min(res, getDiff(tri1, B));
        res = Math.min(res, getDiff(tri2, B));
        res = Math.min(res, getDiff(tri3, B));
        res = Math.min(res, getDiff(tri4, B));
        res = Math.min(res, getDiff(tri5, B));
 
        System.out.println(res);
    }
}
